Subject: [PATCH] ARM: KVM: iterate over all CPUs for CPU compatibility check

From: [email-masked] (Marc Zyngier)
Date: Wed, 17 Apr 2013 14:00:03 +0100

On 17/04/13 13:38, Peter Maydell wrote:
> On 17 April 2013 13:28, Marc Zyngier <[email-masked]> wrote:
>> On 17/04/13 13:25, Peter Maydell wrote:
>>> On 17 April 2013 13:24, Marc Zyngier <[email-masked]> wrote:
>>>> On 17/04/13 12:38, Peter Maydell wrote
>>>>> Who says the code should support running on big.LITTLE?
>>>>
>>>> I do. The host code definitely should. If it doesn't, then lets fix that
>>>> bug, as it probably means the support is also broken on A15.
>>>
>>> Last time I looked we weren't intercepting ID and feature
>>> registers. That's broken if the host isn't A15.
>>
>> Would you please look at the sentence that follows the one you've
>> quoted? It says "guest support is a separate issue". As in "orthogonal
>> problem".
> 
> I'm confused now, because I thought the whole point of this
> patch was that we don't support guests on big.LITTLE but
> we're not locking them out (the way we would for an all-A7
> system). That is, we're fixing a bug in the check code.
> 
> Obviously it seems worth investigating exactly what is
> happening on the A7s when we try to run the init code,
> but it seems to me like that's the orthogonal issue,
> because we shouldn't be running that code in the first
> place.

Turns out that init code was designed to run unchanged on both A15 and
A7. If that code isn't properly working on a HYP-aware CPU, then we're
in trouble.

I don't give a damn about full BL support in KVM at that stage. All I
want is a clear description of *why* that code is failing, and possibly
a way to run guests on the A15 side of a BL platform, without having to
give away half of the cores.

I think I've already spent too much time arguing about this. Hopefully
someone will be interested enough in BL to revert this patch and fix the
code (whether it is in the kernel or bootloader).

	M.
-- 
Jazz is not dead. It just smells funny...